using System;
using System.Data;
using bizFacade;
using MesServerWork;

namespace SyUpLoad
{
    partial class PartLoad
    {
        /// <summary>
        /// 正常逻辑工作(传递机型)
        /// </summary>
        /// <param name="OpName"></param>
        /// <param name="EngineTypeID"></param>
        /// <param name="EngineType"></param>
        /// <param name="EngineID"></param>
        /// <param name="PartPallet_Code"></param>
        private void EngineTypeGetOver_PLC_Work(string OpName, int EngineTypeID, string EngineType, string EngineID, int PartPallet_Code)
        {
            int IsAllowWork;
            int IsrepairBarcode = 0;//拆解返修标志
            int RepairPartStatusPLC = 0;
            int MES_QualityMask = 1;

            string OrderForm = "";//订单号
            string EngineID_MES;
            string repairBarcode = "";//拆解返修条码
            bool MesRead = false;
            bool MesReadOver = false;
            DataTable dt;

            MIS_BASE.Read_EngineID_MES(OpName, out EngineID_MES);//获取MES总成号
            MIS_BASE.Read_MesReadOver(OpName, out MesReadOver);   //保存完成
            MIS_BASE.Read_QualityData_Read_CF(OpName, out MesRead);  //允许保存
            MIS_BASE.Read_PalletInfo(OpName, out  MES_QualityMask);//合格标志
            MIS_BASE.Read_RepairStatus_PLC(OpName, out RepairPartStatusPLC);//返修标志
                                   
            BaseDataSystemMES.GetEngineID_Select(OpName, EngineID, out dt);//查询订单信息
            
            if (dt != null&&dt.Rows.Count > 0)
            {
                OrderForm = Convert.ToString(dt.Rows[0]["订单号"]);
                IsrepairBarcode = Convert.ToInt32(dt.Rows[0]["拆解标志"]);
                repairBarcode = Convert.ToString(dt.Rows[0]["拆解返修条码"]);
            }

            BaseDataSystemMES.OpName_MIS_MOBY_Insert(OpName, OrderForm, EngineTypeID, EngineType, EngineID, PartPallet_Code, 0, IsrepairBarcode, repairBarcode);
            SaveMobyMessage(OpName, EngineTypeID, EngineType, EngineID, OrderForm);
            Sendmessage("5", "1", OpName);
            SendInfomation("QualityMask", Convert.ToString(MES_QualityMask), OpName);
            SendInfomation("RepairPartStatusPLC", Convert.ToString(RepairPartStatusPLC), OpName);

            BaseDataSystemMES.MaterialPush_EngineIDStatus_Insert(OpName);
            
            if (EngineID_MES == EngineID)
            {
                string kuweiNum;
                kuweiNum = DtWebApi.ReadWritePLC.ReadPLC(warehouseLocation.ToString(), OpName).ToString();
                BaseDataSystemMES.GetUpLoadBarCode_0utUpdate(OpName, kuweiNum);
                MIS_BASE.Write_FixAllow(OpName, true);
                InitOpname01();
            }
            else
            {
                AsyncSendMessage_Notice(OpName, "PLC与MES不一致");
            }
        }
        private void InitOpname01()
        {
            BaseDataSystemMES.GetUpLoadBarCode(OPName01, out DataTable dt_OPName01);

            dataGridView_OPA1001.Invoke(new Action(() => {
                dataGridView_OPA1001.DataSource = dt_OPName01;
            }));
        }



        /// <summary>
        /// 保存MOBY信息
        /// </summary>
        /// <param name="OpName"></param>
        /// <param name="engineTypeID"></param>
        /// <param name="engineType"></param>
        /// <param name="engineID"></param>
        private void SaveMobyMessage(string OpName, int engineTypeID, string engineType, string engineID, string orderForm)
        {
            if (MIS_BASE.hashtable_EngineGetOver_EngineTypeID == null)
            {
                MIS_BASE.InitHashtable_MesServerCode();
            }
            if (MIS_BASE.hashtable_EngineGetOver_EngineTypeID.ContainsKey(OpName))
            {
                MIS_BASE.hashtable_EngineGetOver_EngineTypeID[OpName] = engineTypeID;
            }
            if (MIS_BASE.hashtable_EngineGetOver_EngineType.ContainsKey(OpName))
            {
                MIS_BASE.hashtable_EngineGetOver_EngineType[OpName] = engineType;
            }
            if (MIS_BASE.hashtable_EngineGetOver_EngineID.ContainsKey(OpName))
            {
                MIS_BASE.hashtable_EngineGetOver_EngineID[OpName] = engineID;
            }
            if (MIS_BASE.hashtable_EngineGetOver_OrderForm.ContainsKey(OpName))
            {
                MIS_BASE.hashtable_EngineGetOver_OrderForm[OpName] = orderForm;
            }
        }

        /// <summary>
        /// 返修件需要工作
        /// </summary>
        /// <param name="OpName">工位号</param>
        private void IsNeedRepaire_OK(string OpName)
        {

            int isRepair;
            int engineTypeID;

            string engineType = "";
            string engineID = "";
            string palletCode = "";
            string orderForm = "";
            string repairCode = "";
            //从监控系统中查询出本工位信息
            BaseDataSystemMES.OpName_MIS_Moby_Select(OpName,
            out  orderForm, out  engineTypeID, out  engineType,
            out  engineID, out palletCode, out isRepair, out repairCode);

            EngineTypeGetOver_PLC_Work(OpName, engineTypeID, engineType, engineID, Convert.ToInt32(palletCode));
        }

    }
}
